
admm_zoomJGL=
function (Y, XX, K, N, T, lambda1,lambda2,splits,list.controls)
{
par(mfrow=c(2,2))
obj			= initializeMatrices(Y,XX,lambda2,K,N,T)
CX			= obj$CX
CX_			= obj$CX_
CX_X		= obj$CX_X
Zgamma		= obj$Zgamma
S			= obj$S
Zgamma_old	= obj$Zgamma_old
Z			= obj$Z
U			= obj$U
rm(obj)

obj				= createPenalty(Y,K,lambda1,lambda2,list.controls)
regularization1 = obj$regularization1
regularization2 = obj$regularization2
rm(obj)

NegLogLik		= rep(NA,K)
contrib 		= rep(NA,K)
contrib_old 	= rep(0,K)
XZdiff			= rep(NA,K)
XZdiff_old		= rep(Inf,K)
GammaGammadiff	= rep(Inf,K)
mab				= unlist(lapply(Zgamma_old,FUN=function(x){sum(abs(x))}))

iter 		= 0
diff_value1 = diff_value2 = diff_value3 =10
conv 		= NULL

while ((iter == 0) || (iter < list.controls$maxiter && sum(diff_value1,diff_value2,diff_value3) > list.controls$tol)) {

k			= list.controls$kstar
obj			= UpdateAllLevelk(Z[[k]],Zgamma[[k]],U[[k]],S[[k]],CX[[k]],CX_[[k]],CX_X[[k]],lambda2,regularization1[[k]],regularization2[[k]],
list.controls,N,T,iter,GammaGammadiff[k],mab[k])
Z[[k]]		= obj$Z
Zgamma[[k]]	= obj$Zgamma
U[[k]]		= obj$U
S[[k]]		= obj$S
NegLogLik[k]= obj$NegLogLik
contrib[k]	= obj$contrib
XZdiff[k]	= obj$XZdiff
GammaGammadiff[k]=obj$GammaGammadiff
rm(obj)

if(K>1&list.controls$kstar<K)
	 {
	 k=list.controls$kstar+1;flag=F
	 while(flag==F)
		 {
	 obj			= updatePenalty(Y[[1]][[k]],Z[[list.controls$kstar]],Zgamma[[list.controls$kstar]],lambda1,lambda2, list.controls)
	 regularization1[[k]]= obj$regularization1
	 regularization2[[k]]= obj$regularization2
	 rm(obj)
	 obj			= UpdateAllLevelk(Z[[k]],Zgamma[[k]],U[[k]],S[[k]],CX[[k]],CX_[[k]],CX_X[[k]],lambda2,regularization1[[k]],
	 regularization2[[k]],list.controls,N,T,iter,GammaGammadiff[k],mab[k])
	 Z[[k]]			= obj$Z
	 Zgamma[[k]]	= obj$Zgamma
	 U[[k]]			= obj$U
	 S[[k]]			= obj$S
	 NegLogLik[k]	= obj$NegLogLik
	 contrib[k]		= obj$contrib
	 XZdiff[k]		= obj$XZdiff
	 GammaGammadiff[k]=obj$GammaGammadiff
	 rm(obj)
	 if(K>k) {k=k+1; flag=F}
		 else
			 {flag=T}
	
		 }
	 }

 if(K>1&list.controls$kstar>1)
	 {
	 k=list.controls$kstar-1;flag=F
	 while(flag==F)
		 {
	 obj			= updatePenalty(Y[[1]][[k]],Z[[list.controls$kstar]],Zgamma[[list.controls$kstar]],lambda1,lambda2, list.controls)
	 regularization1[[k]]= obj$regularization1
	 regularization2[[k]]= obj$regularization2
	 rm(obj)
	 obj			= UpdateAllLevelk(Z[[k]],Zgamma[[k]],U[[k]],S[[k]],CX[[k]],CX_[[k]],CX_X[[k]],lambda2,
	 regularization1[[k]],regularization2[[k]],list.controls,N,T,iter,GammaGammadiff[k],mab[k])
	 Z[[k]]			= obj$Z
	 Zgamma[[k]]	= obj$Zgamma
	 U[[k]]			= obj$U
	 S[[k]]			= obj$S
	 NegLogLik[k]	= obj$NegLogLik
	 contrib[k]		= obj$contrib
	 XZdiff[k]		= obj$XZdiff
	 GammaGammadiff[k]=obj$GammaGammadiff
	 rm(obj)	
	 if(k>1) {k=k-1; flag=F}
		 else
			 {flag=T}
	
		 }
	 }	
	
# convergence and plotting:
iter 			= iter+1
diff_value1 	= sum(abs(contrib-contrib_old))
contrib_old		= contrib
diff_value2  	= sum(XZdiff)
diff_value3  	= sum(GammaGammadiff)
conv			= rbind(conv,c(iter,diff_value1,diff_value2,diff_value3,sum(contrib),sum(NegLogLik)))
					
if(iter%%25==0){print(iter)}
list.controls$rho = list.controls$rho*list.controls$rho.increment

plot(x=conv[,1],y=conv[,5],type="l",ylab="ObjectiveFunction",xlab="Iteration")
plot(x=conv[,1],y=conv[,2],type="l",col="darkgreen",ylab="ObjectiveFunction at t vs t-1",xlab="Iteration")
plot(x=conv[,1],y=conv[,4],type="l",col="red",ylab=expression(paste("||",Gamma,"||")[F]*' at t vs t-1'),xlab="Iteration")
plot(x=conv[,1],y=conv[,3],type="l",col="blue",ylab=expression(paste("||",Z-Theta,"||")[F]*' at t vs t-1'),xlab="Iteration")

}

out = list(S = S, Z =Z, Z_AR=Zgamma, conv = conv,regularization1=regularization1,regularization2=regularization2)
return(out)
rm(list=ls())
}
