

KSE_stars = function(Y,lambda1,list.controls,t0,t.dat,kern,h)
{

lambda1=sort(lambda1,decreasing=TRUE)


if(is.null(list.controls$stars.subsample.ratio))
	{
		if(nrow(Y[[1]])>144) stars.subsample.ratio = 10*
		sqrt(nrow(Y[[1]]))/nrow(Y[[1]])
		if(nrow(Y[[1]])<=144) stars.subsample.ratio = 0.8
	} 

stability=rep(NA,length(lambda1))
for (j in 1:length(lambda1))
{	
est_Undirected=matrix(0,ncol(Y[[1]]),ncol(Y[[1]]))
for(r in 1:list.controls$rep.num)	
	{ 
	print(paste("Lambda1: ",j," out of ",length(lambda1),sep=""))
	set.seed(2013+j+r)
	sam  	= sample(1:nrow(Y[[1]]),floor(nrow(Y[[1]])*
				stars.subsample.ratio), replace=FALSE)
				
	startpoint=sample(1:(nrow(Y[[1]])-floor(nrow(Y[[1]])*stars.subsample.ratio)),1)
	sam=c(startpoint:(startpoint+floor(nrow(Y[[1]])*stars.subsample.ratio)))
	
	
	Y2		= Y
for (i in 1:length(Y)){Y2[[i]]=Y[[i]][sam,]}
				
	obj	= HQglasso(Y2, t0,t.dat,kern,h,lambda=lambda1[j])
	est_Undirected= est_Undirected+as.matrix(obj$path[[1]])
	}
	est_Undirected=est_Undirected/list.controls$rep.num
	est_varUndirected=4*sum(est_Undirected*(1-est_Undirected))/
							(ncol(Y[[1]])*(ncol(Y[[1]])-1))

	stability[j]=est_varUndirected
}
		
all=cbind(lambda1,stability,stability <= list.controls$stars.thresh)
colnames(all)=c("Lambda1","StARS","IndicatorStARS")	
all2=all
if(any(all[,3]==1)){all2 = matrix(all[which(all[, 3] == 1), ], ncol=ncol(all))}
opt.index			= 1
optimal_lambda_lik	= c(matrix(all2, ncol=3)[,1][opt.index])

return(list(optimal_lambda_lik=optimal_lambda_lik,all=all))
}	



KSE_CV = function(Y,lambda1, kfold=3,t0,t.dat,kern,h)
{
lambda1=sort(lambda1,decreasing=TRUE)
lik_3foldcv = rep(0,length(lambda1))

for (j in 1:length(lambda1))
{
	print(paste("Lambda1: ",j," out of ",length(lambda1),sep=""))
	set.seed(2013+j)
	sam  	= sample(1:nrow(Y[[1]]))
	sam  	= split(sam, c(rep(1:kfold, each =ceiling(nrow(Y[[1]])/kfold)),1)) 
	
	sam  	= (1:nrow(Y[[1]]))
	sam  	= split(sam, c(rep(1:kfold, each =ceiling(nrow(Y[[1]])/kfold)),1)) 
	
	err1	= NULL
	err2	= NULL
	Y2		= Y
	Y3		= Y
	for(drop in 1: kfold)
	{
		for (i in 1:length(Y)){
		Y2[[i]]=Y[[i]][-sam[[drop]],]
		Y3[[i]]=Y[[i]][sam[[drop]],]
		}
			
	obj	= HQglasso(Y2, t0,t.dat,kern,h,lambda=lambda1[j])
		
	N	= length(Y3)
	T	= nrow(Y3[[1]])

	S 			<- Reduce('+',lapply(seq_along(Y3), 
					function(i){Matrix::crossprod(Y3[[i]])}))/(N*T)	
	expr		= (sum(diag(as.matrix(S%*%obj$icov[[1]]))) - 
					log(det(as.matrix(obj$icov[[1]]))))
		
	err1 = c(err1,expr)
	}	
	
lik_3foldcv[j]				= mean(err1)	
}		
optimal_lambda_lik			= lambda1[which.min(lik_3foldcv)]
	
all				= cbind(lambda1,lik_3foldcv)
colnames(all)	= c("Lambda1","3foldAverageLikLoss")
		
return(list(optimal_lambda_lik=optimal_lambda_lik,all=all))
}


