
TSCGM_stars = function(Y,lambda1,lambda2,list.controls)
{

if(is.null(list.controls$stars.subsample.ratio))
	{
		if(nrow(Y[[1]])>144) stars.subsample.ratio = 10*
		sqrt(nrow(Y[[1]]))/nrow(Y[[1]])
		if(nrow(Y[[1]])<=144) stars.subsample.ratio = 0.8
	} 


lambda=expand.grid(sort(lambda2,decreasing=TRUE),sort(lambda1,decreasing=TRUE))
lambda=cbind(lambda[,2],lambda[,1])
colnames(lambda)=c("Lambda1","Lambda2")

	
stability=rep(NA,nrow(lambda))

for (j in 1:nrow(lambda))
{	

est_Undirected=matrix(0,ncol(Y[[1]]),ncol(Y[[1]]))
est_Directed=matrix(0,ncol(Y[[1]]),ncol(Y[[1]]))

for(r in 1:list.controls$rep.num)	
	{ 
	print(paste("Lambda1-Lambda2 combination: ",j," out of ",nrow(lambda),sep=""))
	set.seed(2013+j+r)
	sam  	= sample(1:nrow(Y[[1]]),floor(nrow(Y[[1]])*
				stars.subsample.ratio), replace=FALSE)
	
	startpoint=sample(1:(nrow(Y[[1]])-floor(nrow(Y[[1]])*stars.subsample.ratio)),1)
	sam=c(startpoint:(startpoint+floor(nrow(Y[[1]])*stars.subsample.ratio)))
		

Y2		= Y
for (i in 1:length(Y)){Y2[[i]]=Y[[i]][sam,]}			

	
full_mat=NULL
for (i in 1:nrow(Y2[[1]])){
full_mat=rbind(full_mat,do.call(rbind,lapply(Y2,FUN=function(x){x[i,]})))
}
full_mat=as.longitudinal(full_mat,repeats=length(Y))		


	
		
 obj <- sparse.tscgm(data=full_mat, lambda[j,1], lambda[j,2],
 model="ar1", optimality="NULL",control=list(maxit.out = 10, maxit.in = 30))

	est_Undirected= est_Undirected+Conc2Adj(obj$theta)
	est_Directed= est_Directed+AR2Adj(obj$gamma)
	
	}
	est_Undirected=est_Undirected/list.controls$rep.num
	est_Directed=est_Directed/list.controls$rep.num
	
	est_varUndirected=4*sum(est_Undirected*(1-est_Undirected))/
							(ncol(Y[[1]])*(ncol(Y[[1]])-1))
	est_varDirected=2*sum(est_Directed*(1-est_Directed))/(ncol(Y[[1]])^2)						
							
	stability[j]=est_varUndirected+est_varDirected
}
	
all=cbind(lambda,stability,stability <= list.controls$stars.thresh)
colnames(all)=c("Lambda1","Lambda2","StARS","IndicatorStARS")	
all2=all
if(any(all[,4]==1)){all2 = matrix(all[which(all[, 4] == 1), ], ncol=ncol(all))}
opt.index			= 1
optimal_lambda_lik	= c(matrix(all2, ncol=4,byrow=F)[,1][opt.index],matrix(all2, ncol=4,byrow=F)[,2][opt.index])

return(list(optimal_lambda_lik=optimal_lambda_lik,all=all))

}					


TSCGM_CV = function(Y,lambda1,lambda2, kfold=3, model)
{


	lambda=expand.grid(sort(lambda2,decreasing=TRUE),sort(lambda1,decreasing=TRUE))
	lambda=cbind(lambda[,2],lambda[,1])
	colnames(lambda)=c("Lambda1","Lambda2")

	lik_3foldcv									= rep(0,nrow(lambda))

for (j in 1:nrow(lambda))
{
	print(paste("Lambda1-Lambda2 combination: ",j," out of ",nrow(lambda),sep=""))
	set.seed(2013+j)
	sam  	= sample(1:nrow(Y[[1]]))
	sam  	= split(sam, c(rep(1:kfold, each =ceiling(nrow(Y[[1]])/kfold)),1)) 
	
	sam  	= (1:nrow(Y[[1]]))
	sam  	= split(sam, c(rep(1:kfold, each =ceiling(nrow(Y[[1]])/kfold)),1)) 
	
	err1	= NULL
	err2	= NULL
	Y2		= Y
	Y3		= Y
	for(drop in 1: kfold)
	{
		for (i in 1:length(Y)){
		Y2[[i]]=Y[[i]][-sam[[drop]],]
		Y3[[i]]=Y[[i]][sam[[drop]],]
		}
			
	

full_mat=NULL
for (i in 1:nrow(Y2[[1]])){
full_mat=rbind(full_mat,do.call(rbind,lapply(Y2,FUN=function(x){x[i,]})))
}
full_mat=as.longitudinal(full_mat,repeats=length(Y3))		
		
		
obj <- sparse.tscgm(data=full_mat, lambda[j,1], lambda[j,2],
 model="ar1", optimality="NULL",control=list(maxit.out = 10, maxit.in = 30))

 
	N	= length(Y3)
	T	= nrow(Y3[[1]])
		
	if (model=="AR1") {
	XX=Y3
	for (i in 1: N){
	XX[[i]]=Y3[[i]][1:(T-1),]
	Y3[[i]]=Y3[[i]][2:T,]
	}}
	
	if (model=="AR2") {
	X1=X2=Y3
	for (i in 1: N){
	X2[[i]]=Y3[[i]][2:(T-1),]
	X1[[i]]=Y3[[i]][1:(T-2),]
	Y3[[i]]=Y3[[i]][3:T,]
	}
	XX <- abind(X1, X2,along = 2 )
	}
	

	
	
CX	 	<- Reduce('+',lapply(seq_along(Y3), 
function(i){.Call("R_txx", R_x=as.matrix(Y3[[i]]),PACKAGE = "zoomJGL")$tXX}))
CX_ 	<- Reduce('+',lapply(seq_along(Y3), 
function(i){.Call("R_txx", R_x=as.matrix(XX[[i]]),PACKAGE = "zoomJGL")$tXX}))
CX_X	<- Reduce('+',lapply(seq_along(Y3), 
function(i){.Call("R_txy", R_x=as.matrix(XX[[i]]),R_y=as.matrix(Y3[[i]]),PACKAGE = "zoomJGL")$tXY}))

CX		= CX/(N*T)
CX_		= CX_/(N*T)
CX_X	= CX_X/(N*T)


S 		= CX-.Call("R_txy", R_x=CX_X,R_y=obj$gamma,PACKAGE = "zoomJGL")$tXY-
					  .Call("R_txy", R_x=obj$gamma,R_y=CX_X,PACKAGE = "zoomJGL")$tXY+
					  .Call("R_txyz", R_x=obj$gamma,R_y=CX_,R_C=obj$gamma,PACKAGE = "zoomJGL")$tXYZ
	
	expr	=	 sum(diag(.Call("R_xy", R_x=S,R_y=obj$theta,PACKAGE = "zoomJGL")$XY))-
			      sum(log(.Call("R_eigen_decom2", R_A=obj$theta,PACKAGE = "zoomJGL")$values))
	
		
	err1 = c(err1,expr)
	}	
	
lik_3foldcv[j]				= mean(err1)	
 
 }		
optimal_lambda_lik			= lambda[which.min(lik_3foldcv),]
	
all				= cbind(lambda,lik_3foldcv)
colnames(all)	= c("Lambda1","Lambda2","3foldAverageLikLoss")
		
return(list(optimal_lambda_lik=optimal_lambda_lik,all=all))
}

