

JGL=function(Y,lambda1, 
list.controls=list(penalize.diagonal=FALSE,
rho=1,rho.increments=1,maxiter=300,tol=1e-2,alpha=0.7,truncate=1e-5,
stars.thresh = 0.1, stars.subsample.ratio = NULL, rep.num = 5))
{
N	= length(Y)
K 	= length(Y[[1]])
T	= nrow(Y[[1]][[1]])

obj		= admmJGL(Y,K,N,T, lambda1,list.controls)
obj		= killSmallJGL(obj,list.controls)
obj2	= createAdjacencyJGL(obj)
	
nonzero_Undirected	= sum(unlist(lapply(obj2$Undirected,FUN=function(x){sum(x[upper.tri(x)])})))
vars_Undirected		= sum(unlist(lapply(obj2$Undirected,FUN=function(x){ncol(x)})))
		

#Yuan&Li 2007
BIC_1= obj$conv[nrow(obj$conv),5]+(log(N*T)/(N*T))*(nonzero_Undirected)
AIC_1= obj$conv[nrow(obj$conv),5]+(2/(N*T))*(nonzero_Undirected) # NOT DEFINED BY THE AUTHORS
#Yin&Li 2011
BIC_2= (N*T)*obj$conv[nrow(obj$conv),5]+log(N*T)*(nonzero_Undirected+vars_Undirected)
#Foygel&Drton
BIC_3= (N*T)*obj$conv[nrow(obj$conv),5]+log(N*T)*(nonzero_Undirected)

#Foygel&Drton 
mygamma=0.1
eBIC_1= (N*T)*obj$conv[nrow(obj$conv),5]+log(N*T)*(nonzero_Undirected)+4*(nonzero_Undirected)*mygamma
mygamma=0.5
eBIC_2= (N*T)*obj$conv[nrow(obj$conv),5]+log(N*T)*(nonzero_Undirected)+4*(nonzero_Undirected)*mygamma
mygamma=0.9
eBIC_3= (N*T)*obj$conv[nrow(obj$conv),5]+log(N*T)*(nonzero_Undirected)+4*(nonzero_Undirected)*mygamma
	 
	 
	 
	 


colnames(obj$conv)	= c("Iter", "DiffObjective", "DiffZTheta","ObjectiveFunc", "NegLogLik")	
out 			= list(Theta=obj$Z,Undirected=obj2$Undirected,
					Convergence=obj$conv, IC=list(AIC_1=AIC_1,BIC_1=BIC_1,BIC_2=BIC_2,BIC_3=BIC_3,eBIC_1=eBIC_1,eBIC_2=eBIC_2,eBIC_3=eBIC_3),
					Lambda=lambda1)
return(out)
rm(list=ls())
}


admmJGL=
function (Y, K, N, T, lambda1, list.controls)
{
# Initialize CX, CX_,CXX_,Zgamma,S,Zgamma_old,Z,U
obj			= intializeMatricesJGL(Y,K,N,T)
S			= obj$S
Z			= obj$Z
U			= obj$U

# Create regularization1,regularization2
obj				= createPenaltyJGL(Y,K,lambda1,list.controls)
regularization1 = obj$regularization1

NegLogLik		= rep(NA,K)
contrib 		= rep(NA,K)
contrib_old 	= rep(0,K)
XZdiff			= rep(NA,K)
XZdiff_old		= rep(Inf,K)

iter = 0
diff_value1 = diff_value2 = 10
conv = NULL

while ((iter == 0) || (iter < list.controls$maxiter && 
		sum(diff_value1,diff_value2) > list.controls$tol)) {

# Update Z,U at level 1
edecomp		= .Call("R_eigen_decom2", R_A=(list.controls$rho*as.matrix(Z[[1]]) - 
				list.controls$rho*as.matrix(U[[1]]) - as.matrix(S[[1]])),PACKAGE = "zoomJGL")
D2 			= (edecomp$values+sqrt(edecomp$values^2 + 4*list.controls$rho))*(1/(2*list.controls$rho))
X			= .Call("R_xytx", R_x=edecomp$vectors,R_y=diag(D2),PACKAGE = "zoomJGL")[[1]]
colnames(X)	= colnames(S[[1]])
rownames(X)	= colnames(S[[1]])
Zold 		= as.matrix(Z[[1]])
X_hat 		= list.controls$alpha*X + (1 - list.controls$alpha)*Zold
Z[[1]]		= soft(X_hat+as.matrix(U[[1]]),regularization1[[1]])
U[[1]] 		= U[[1]] + (X_hat - Z[[1]])
NegLogLik[1]= sum(diag(as.matrix(S[[1]]%*%X))) - log(det(X))
contrib[1]	= NegLogLik[1] + sum(abs(regularization1[[1]]*Z[[1]])) 
XZdiff[1]	= norm(X - Z[[1]],"F")

if(K>1)
	{
	k=2;flag=F
	while(flag==F)
		{
edecomp		= .Call("R_eigen_decom2", R_A=(list.controls$rho*as.matrix(Z[[k]]) - 
				list.controls$rho*as.matrix(U[[k]]) - as.matrix(S[[k]])),PACKAGE = "zoomJGL")
D2 			= (edecomp$values+sqrt(edecomp$values^2 + 4*list.controls$rho))*(1/(2*list.controls$rho))
X			= .Call("R_xytx", R_x=edecomp$vectors,R_y=diag(D2),PACKAGE = "zoomJGL")[[1]]
colnames(X) = colnames(S[[k]])
rownames(X)	= colnames(S[[k]])
Zold 		= as.matrix(Z[[k]])
X_hat 		= list.controls$alpha*X + (1 - list.controls$alpha)*Zold
Z[[k]]		= soft(X_hat+as.matrix(U[[k]]),regularization1[[k]])
U[[k]] 		= U[[k]] + (X_hat - Z[[k]])
NegLogLik[k]= sum(diag(as.matrix(S[[k]]%*%X))) - log(det(X))
contrib[k]  = NegLogLik[k]+ sum(abs(regularization1[[k]]*Z[[k]])) 
XZdiff[k]	= norm(X - Z[[k]],"F")

if(K>k) {k=k+1; flag=F}
		else
			{flag=T}
		}
	}


# convergence and plotting:
iter 			= iter+1
diff_value1 	= sum(abs(contrib-contrib_old))
contrib_old		= contrib
diff_value2  	= sum(XZdiff)
conv			= rbind(conv,c(iter,diff_value1,diff_value2,sum(contrib),sum(NegLogLik)))
					
par(mfrow=c(2,2))
plot(x=conv[,1],y=conv[,4],type="l",ylab="ObjectiveFunction",xlab="Iteration")
plot(x=conv[,1],y=conv[,2],type="l",col="darkgreen",ylab="ObjectiveFunction at t vs t-1",xlab="Iteration")
plot(x=conv[,1],y=conv[,3],type="l",col="blue",ylab=expression(paste("||",Z-Theta,"||")[F]*' at t vs t-1'),xlab="Iteration")

if(iter%%25==0){print(iter)}
list.controls$rho = list.controls$rho*list.controls$rho.increment
}
S=lapply(S,FUN=function(x){as(x, "dgCMatrix")})
Z=lapply(Z,FUN=function(x){as(x, "dgCMatrix")})

    out = list(S = S, Z =Z, conv = conv)
    return(out)
	rm(list=ls())
}

createAdjacencyJGL=function(obj)
{
	Undirected	= obj$Z
	for (k in 1:length(obj$Z)){
	Undirected[[k]][Undirected[[k]]!=0]	= 1
	diag(Undirected[[k]])				= 0
	Undirected[[k]]=as(Undirected[[k]], "dgCMatrix")
	}
	return(list(Undirected=Undirected))
	rm(list=ls())
}


JGL_CV = function(Y,lambda1, kfold=3,list.controls)
{

lambda1=sort(lambda1,decreasing=TRUE)
lik_3foldcv = rep(0,length(lambda1))

for (j in 1:length(lambda1))
{
	print(paste("Lambda1: ",j," out of ",length(lambda1),sep=""))
	set.seed(2013+j)
	sam  	= sample(1:nrow(Y[[1]][[1]]))
	sam  	= split(sam, c(rep(1:kfold, each =ceiling(nrow(Y[[1]][[1]])/kfold)),1)) 
	
	sam  	= (1:nrow(Y[[1]][[1]]))
	sam  	= split(sam, c(rep(1:kfold, each =ceiling(nrow(Y[[1]][[1]])/kfold)),1)) 
	
	err1	= NULL
	err2	= NULL
	Y2		= Y
	Y3		= Y
	for(drop in 1: kfold)
	{
		for (i in 1:length(Y)){
		for (k in 1:length(Y[[i]])){
		Y2[[i]][[k]]=Y[[i]][[k]][-sam[[drop]],]
		Y3[[i]][[k]]=Y[[i]][[k]][sam[[drop]],]
		}}
			
	obj	= JGL(Y2, lambda1[j],list.controls=list.controls)
		
	N	= length(Y3)
	K 	= length(Y3[[1]])
	T	= nrow(Y3[[1]][[1]])
		
	S				=vector("list",K)
	expr			=rep(NA,K)
	for (k in 1: K)
		{
	S[[k]] 			<- Reduce('+',lapply(seq_along(Y3), 
					function(i,k){Matrix::crossprod(Y3[[i]][[k]])}, k=k))/(N*T)	
	expr[k]		= (sum(diag(as.matrix(S[[k]]%*%obj$Theta[[k]]))) - 
					log(det(as.matrix(obj$Theta[[k]]))))
		}
	err1 = c(err1,sum(expr))
	}	
	
lik_3foldcv[j]				= mean(err1)	
}		
optimal_lambda_lik			= lambda1[which.min(lik_3foldcv)]
	
all				= cbind(lambda1,lik_3foldcv)
colnames(all)	= c("Lambda1","3foldAverageLikLoss")
		
return(list(optimal_lambda_lik=optimal_lambda_lik,all=all))
}


intializeMatricesJGL=function(Y,K,N,T)
{
S				= vector("list",K)
Z				= vector("list",K)
U				= vector("list",K)
for (k in 1: K){
S[[k]] 			<- Reduce('+',lapply(seq_along(Y), 
					function(i,k){Matrix::crossprod(Y[[i]][[k]])}, k=k))/(N*T)
Z[[k]]	 	 	<- Matrix(0,dim(S[[k]])[2],dim(S[[k]])[2])
U[[k]]	 	 	<- Matrix(0,dim(S[[k]])[2],dim(S[[k]])[2])
}
return(list(S=S,Z=Z,U=U))
}


killSmallJGL=function(obj,list.controls)
{
	for (k in 1:length(obj$Z)){
	rounddown1 		= abs(obj$Z[[k]])<list.controls$truncate; 
	diag(rounddown1)= FALSE
	obj$Z[[k]]		<- obj$Z[[k]]*(1-rounddown1)
	}
	return(obj)
}



createPenaltyJGL=function(Y,K,lambda1, list.controls)
{
regularization1	= vector("list",K)
for (k in 1: K){
regularization1[[k]] <- penalty.as.matrix(lambda1, ncol(Y[[1]][[k]]), penalize.diagonal = list.controls$penalize.diagonal)
colnames(regularization1[[k]])	<-colnames(Y[[1]][[k]])
rownames(regularization1[[k]])	<-colnames(Y[[1]][[k]])
if(list.controls$penalize.diagonal==T) 
	{diag(regularization1[[k]]) <-lambda1} 
	else 
	{diag(regularization1[[k]]) <-0}
}
return(list(regularization1=regularization1))
}



JGL_stars = function(Y,lambda1,list.controls)
{

lambda1=sort(lambda1,decreasing=TRUE)
if(is.null(list.controls$stars.subsample.ratio))
	{
		if(nrow(Y[[1]][[1]])>144) stars.subsample.ratio = 10*
		sqrt(nrow(Y[[1]][[1]]))/nrow(Y[[1]][[1]])
		if(nrow(Y[[1]][[1]])<=144) stars.subsample.ratio = 0.8
	} 

est_Undirected=vector("list",length(Y[[1]]))		
est_varUndirected=vector("list",length(Y[[1]]))	
stability=rep(NA,length(lambda1))

dims=unlist(lapply(Y[[1]],ncol))
for (i in 1: length(dims)) {est_Undirected[[i]]=matrix(0,dims[i],dims[i])}	

for (j in 1:length(lambda1))
{
	dims=unlist(lapply(Y[[1]],ncol))
	for (i in 1: length(dims))
	{est_Undirected[[i]]=matrix(0,dims[i],dims[i])}	

for(r in 1:list.controls$rep.num)	
	{ 
	print(paste("Lambda1: ",j," out of ",length(lambda1),sep=""))
	set.seed(2013+j+r)
	sam  	= sample(1:nrow(Y[[1]][[1]]),floor(nrow(Y[[1]][[1]])*
				stars.subsample.ratio), replace=FALSE)
				
	startpoint=sample(1:(nrow(Y[[1]][[1]])-floor(nrow(Y[[1]][[1]])*stars.subsample.ratio)),1)
	sam=c(startpoint:(startpoint+floor(nrow(Y[[1]][[1]])*stars.subsample.ratio)))
				
	Y2		= Y
	
	for (i in 1:length(Y)){
	for (k in 1:length(Y[[i]])){
	Y2[[i]][[k]]=Y[[i]][[k]][sam,]
	}}
				
	obj	= JGL(Y2, lambda1[j],list.controls=list.controls)
	est_Undirected= mapply("+",est_Undirected,obj$Undirected)
	}
	for (ii in 1: length(Y[[1]])){
	est_Undirected[[ii]]=est_Undirected[[ii]]/list.controls$rep.num
	est_varUndirected[[ii]]=4*sum(est_Undirected[[ii]]*(1-est_Undirected[[ii]]))/
							(dims[ii]*(dims[ii]-1))
	}
	
	stability[j]=sum(unlist(est_varUndirected))
}
	
all=cbind(lambda1,stability,stability <= list.controls$stars.thresh)
colnames(all)=c("Lambda1","StARS","IndicatorStARS")	

all2=all
if(any(all[,3]==1)){all2 = matrix(all[which(all[, 3] == 1), ], ncol=ncol(all))}

opt.index			= 1
optimal_lambda_lik	= c(matrix(all2, ncol=3,byrow=F)[,1][opt.index])
return(list(optimal_lambda_lik=optimal_lambda_lik,all=all))
}	
		