
CV.zoomJGL = function(Y,lambda1,lambda2, list.controls)
{

lambda=expand.grid(sort(lambda2,decreasing=TRUE),sort(lambda1,decreasing=TRUE))
lambda=cbind(lambda[,2],lambda[,1])
colnames(lambda)=c("Lambda1","Lambda2")


lik_3foldcv									= rep(0,nrow(lambda))
averagescale_lik_3foldcv=matrix(0,nrow(lambda),length(Y[[1]]))

for (j in 1:nrow(lambda))
{
	print(paste("Lambda1-Lambda2 combination: ",j," out of ",nrow(lambda),sep=""))
	set.seed(2013+j)
	sam  	= sample(1:nrow(Y[[1]][[1]]))
	
	sam  	= (1:nrow(Y[[1]][[1]]))
	sam  	= split(sam, c(rep(1:list.controls$kfold, each =ceiling(nrow(Y[[1]][[1]])/list.controls$kfold)),1)) 
	err1	= NULL
	err2	= NULL
	err3	= NULL
	Y2		= Y
	Y3		= Y
	for(drop in 1: list.controls$kfold)
	{
		for (i in 1:length(Y)){
		for (k in 1:length(Y[[i]])){
		Y2[[i]][[k]]=Y[[i]][[k]][-sam[[drop]],]
		Y3[[i]][[k]]=Y[[i]][[k]][sam[[drop]],]
		}}
			
	obj	= zoomJGL(Y2, lambda[j,1], lambda[j,2], list.controls=list.controls)
		
	N	= length(Y3)
	K 	= length(Y3[[1]])
	T	= nrow(Y3[[1]][[1]])
		
	if (list.controls$model=="AR1") {
	XX=Y3
	for (i in 1: N){
	for (k in 1: K){
	XX[[i]][[k]]=Y3[[i]][[k]][1:(T-1),]
	Y3[[i]][[k]]=Y3[[i]][[k]][2:T,]
	}}}
	
	if (list.controls$model=="AR2") {
	X1=X2=Y3
	for (i in 1: N){
	for (k in 1: K){
	X2[[i]][[k]]=Y3[[i]][[k]][2:(T-1),]
	X1[[i]][[k]]=Y3[[i]][[k]][1:(T-2),]
	Y3[[i]][[k]]=Y3[[i]][[k]][3:T,]
	}}
	XX <- abind(X1, X2,along = 2 )
	}
	
	CX				=vector("list",K)
	CX_X			=vector("list",K)
	CX_				=vector("list",K)
	S				=vector("list",K)
	expr			=rep(NA,K)
	expr2			=rep(NA,K)

	for (k in 1: K)
		{
		
	
CX[[k]]	 	<- Reduce('+',lapply(seq_along(Y3), 
function(i,k){.Call("R_txx", R_x=as.matrix(Y3[[i]][[k]]),PACKAGE = "zoomJGL")$tXX}, k=k))
CX_[[k]] 	<- Reduce('+',lapply(seq_along(Y3), 
function(i,k){.Call("R_txx", R_x=as.matrix(XX[[i]][[k]]),PACKAGE = "zoomJGL")$tXX}, k=k))
CX_X[[k]]	<- Reduce('+',lapply(seq_along(Y3), 
function(i,k){.Call("R_txy", R_x=as.matrix(XX[[i]][[k]]),R_y=as.matrix(Y3[[i]][[k]]),PACKAGE = "zoomJGL")$tXY}, k=k))

CX[[k]]		= CX[[k]]/(N*T)
CX_[[k]]	= CX_[[k]]/(N*T)
CX_X[[k]]	= CX_X[[k]]/(N*T)


S[[k]] 		= CX[[k]]-.Call("R_txy", R_x=CX_X[[k]],R_y=obj$Gamma[[k]],PACKAGE = "zoomJGL")$tXY-
					  .Call("R_txy", R_x=obj$Gamma[[k]],R_y=CX_X[[k]],PACKAGE = "zoomJGL")$tXY+
					  .Call("R_txyz", R_x=obj$Gamma[[k]],R_y=CX_[[k]],R_C=obj$Gamma[[k]],PACKAGE = "zoomJGL")$tXYZ
	
		
	expr[k]	=	 sum(diag(.Call("R_xy", R_x=S[[k]],R_y=obj$Theta[[k]],PACKAGE = "zoomJGL")$XY))-
			      sum(log(.Call("R_eigen_decom2", R_A=obj$Theta[[k]],PACKAGE = "zoomJGL")$values))
	expr2[k]	=expr[k]/ncol(S[[k]])			
		}
	err1 = rbind(err1,expr)
	err3 = rbind(err3,expr2)
	}	
	
lik_3foldcv[j]				= sum(colMeans(err1))	
averagescale_lik_3foldcv[j,]= colMeans(err3)
}		
optimal_lambda_lik			= lambda[which.min(lik_3foldcv),]
optimal_scale = 	which.min(averagescale_lik_3foldcv[which.min(lik_3foldcv),])
	
all				= cbind(lambda,lik_3foldcv,averagescale_lik_3foldcv)
colnames(all)	= c("Lambda1","Lambda2","3foldAverageLikLoss",paste("NodewiseCVE_Scale",1:length(Y[[1]]),sep=""))
		
return(list(optimal_lambda_lik=optimal_lambda_lik,optimal_scale=optimal_scale,all=all))
}


