
penalty.as.matrix=
function (lambda, p, penalize.diagonal) 
{
    if (is.matrix(lambda)) {
        if (sum(lambda != t(lambda)) > 0) {
            stop("error: penalty matrix is not symmetric")
        }
        if (sum(abs(dim(lambda) - p)) != 0) {
            stop("error: penalty matrix has wrong dimension")
        }
    }
    if (length(lambda) == 1) {
        lambda = matrix(lambda, p, p)
    }
    if (!penalize.diagonal) {
        diag(lambda) = 0
    }
    return(lambda)
}

createPenalty=function(Y,K,lambda1,lambda2, list.controls)
{
myfloor=list.controls$kstar
regularization1	= vector("list",K)
regularization2	= vector("list",K)

regularization1[[myfloor]] <- penalty.as.matrix(lambda1, ncol(Y[[1]][[myfloor]]), penalize.diagonal = list.controls$penalize.diagonal)
regularization2[[myfloor]] <- penalty.as.matrix(lambda2, ncol(Y[[1]][[myfloor]]), penalize.diagonal = T)

for (k in setdiff(1:K,myfloor)){
regularization1[[k]] 			<- penalty.as.matrix(1000000, ncol(Y[[1]][[k]]), penalize.diagonal = list.controls$penalize.diagonal)
colnames(regularization1[[k]])	<- colnames(Y[[1]][[k]])
rownames(regularization1[[k]])	<- colnames(Y[[1]][[k]])
regularization2[[k]] 			<- penalty.as.matrix(1000000, ncol(Y[[1]][[k]]), penalize.diagonal = T)
colnames(regularization2[[k]])	<- colnames(Y[[1]][[k]])
rownames(regularization2[[k]])	<- colnames(Y[[1]][[k]])
if(list.controls$penalize.diagonal==T) 
	{diag(regularization1[[k]]) <-lambda1} 
	else 
	{diag(regularization1[[k]]) <-0}
}
return(list(regularization1=regularization1,regularization2=regularization2))
}


updatePenalty=function(myY,myZ,myZgamma,lambda1,lambda2,list.controls)
{
regularization1 		 	= penalty.as.matrix(1000000, ncol(myY), penalize.diagonal = list.controls$penalize.diagonal)
regularization2		 	 	= penalty.as.matrix(1000000, ncol(myY), penalize.diagonal = T)
colnames(regularization1)	= colnames(myY)
rownames(regularization1)	= colnames(myY)
colnames(regularization2)	= colnames(myY)
rownames(regularization2)	= colnames(myY)

coarser						= matrix(unlist(strsplit(colnames(myY),"_")),ncol=2,byrow=T)[,1]
finer						= matrix(unlist(strsplit(colnames(myZ),"_")),ncol=2,byrow=T)[,1]

if (any(myZ!=0)==TRUE)
 {
 indexes					= which(myZ!=0,arr.ind=T)
 for (myind in 1: nrow(indexes))
  {
	regularization1[which(coarser %in% finer[indexes[myind,]][1]),
				    which(coarser %in% finer[indexes[myind,]][2])]=lambda1
  }
 }
diag(regularization1) 		= 0 
if(list.controls$penalize.diagonal==T) diag(regularization1) = lambda1

if (any(myZgamma!=0)==TRUE)
 {
 indexes					= which(myZgamma!=0,arr.ind=T)
 for (myind in 1: nrow(indexes))
  {
   regularization2[which(coarser %in% finer[indexes[myind,]][1]),
				   which(coarser %in% finer[indexes[myind,]][2])]=lambda2
  }
 }

return(list(regularization1=regularization1,regularization2=regularization2))
}

