
zoomJGL=function(Y,lambda1,lambda2,
list.controls=list(model="AR1",penalize.diagonal=FALSE,kstar=1,
rho=1,rho.increments=1,maxiter=200,tol=1e-02,alpha=0.7))
{

N	= length(Y)
K 	= length(Y[[1]])
T	= nrow(Y[[1]][[1]])
if (list.controls$model=="AR1") {obj=createAR1(Y,N,K,T)}
if (list.controls$model=="AR2") {obj=createAR2(Y,N,K,T)}

splits=vector("list",K)
for (k in 1:K){
splits[[k]]=matrix(unlist(strsplit(colnames(Y[[1]][[k]]),"_")),ncol=2,byrow=T)[,1]
}

obj_1			= admm_zoomJGL(obj$Y,obj$XX,K,N,T-1,lambda1,lambda2,splits,list.controls)
obj				= obj_1 
obj2			= createAdjacency(obj)
regularization1	= obj$regularization1
regularization2	= obj$regularization2

rm(obj_1)


nonzero_Undirected	= sum(unlist(lapply(obj2$Undirected,FUN=function(x){sum(x[upper.tri(x)])})))
nonzero_Directed	= sum(unlist(lapply(obj2$Directed,FUN=function(x){sum(x)})))
vars_Undirected		= sum(unlist(lapply(obj2$Undirected,FUN=function(x){ncol(x)})))
vars_Directed		= sum(unlist(lapply(obj2$Directed,FUN=function(x){ncol(x)})))


#Yuan&Li 2007
BIC_1= obj$conv[nrow(obj$conv),6]+(log(N*T)/(N*T))*(nonzero_Undirected+nonzero_Directed)
AIC_1= obj$conv[nrow(obj$conv),6]+(2/(N*T))*(nonzero_Undirected+nonzero_Directed) # NOT DEFINED BY THE AUTHORS
#Yin&Li 2011
BIC_2= (N*T)*obj$conv[nrow(obj$conv),6]+log(N*T)*(nonzero_Undirected+nonzero_Directed+vars_Undirected)
#Foygel&Drton
BIC_3= (N*T)*obj$conv[nrow(obj$conv),6]+log(N*T)*(nonzero_Undirected+nonzero_Directed)

#Foygel&Drton 
mygamma=0.1
eBIC_1= (N*T)*obj$conv[nrow(obj$conv),6]+log(N*T)*(nonzero_Undirected+nonzero_Directed)+4*(nonzero_Undirected+nonzero_Directed)*mygamma
mygamma=0.5
eBIC_2= (N*T)*obj$conv[nrow(obj$conv),6]+log(N*T)*(nonzero_Undirected+nonzero_Directed)+4*(nonzero_Undirected+nonzero_Directed)*mygamma
mygamma=0.9
eBIC_3= (N*T)*obj$conv[nrow(obj$conv),6]+log(N*T)*(nonzero_Undirected+nonzero_Directed)+4*(nonzero_Undirected+nonzero_Directed)*mygamma
	 
	 
colnames(obj$Z[[1]])=matrix(unlist(strsplit(colnames(Y[[1]][[1]]),"_")),ncol=2,byrow=T)[,1]
colnames(obj$Z_AR[[1]])=matrix(unlist(strsplit(colnames(Y[[1]][[1]]),"_")),ncol=2,byrow=T)[,1]
colnames(obj2$Undirected[[1]])=matrix(unlist(strsplit(colnames(Y[[1]][[1]]),"_")),ncol=2,byrow=T)[,1]
colnames(obj2$Directed[[1]])=matrix(unlist(strsplit(colnames(Y[[1]][[1]]),"_")),ncol=2,byrow=T)[,1]

rownames(obj$Z[[1]])=matrix(unlist(strsplit(colnames(Y[[1]][[1]]),"_")),ncol=2,byrow=T)[,1]
rownames(obj$Z_AR[[1]])=matrix(unlist(strsplit(colnames(Y[[1]][[1]]),"_")),ncol=2,byrow=T)[,1]
rownames(obj2$Undirected[[1]])=matrix(unlist(strsplit(colnames(Y[[1]][[1]]),"_")),ncol=2,byrow=T)[,1]
rownames(obj2$Directed[[1]])=matrix(unlist(strsplit(colnames(Y[[1]][[1]]),"_")),ncol=2,byrow=T)[,1]

colnames(obj$conv)	= c("Iter", "DiffObjective", "DiffZTheta","DiffGamma","ObjectiveFunc", "NegLogLik")	
out 			= list(Theta=obj$Z,Gamma=obj$Z_AR,Undirected=obj2$Undirected, Directed=obj2$Directed,
					Constraint1=regularization1,Constraint2=regularization2,
					Convergence=obj$conv, IC=list(AIC_1=AIC_1,BIC_1=BIC_1,BIC_2=BIC_2,BIC_3=BIC_3,eBIC_1=eBIC_1,eBIC_2=eBIC_2,eBIC_3=eBIC_3),
					Lambda=c(lambda1,lambda2))
return(out)
rm(list=ls())
}

