#include <math.h>
#include <stdlib.h>


double **make_mat(int nrow, int ncol);
void delete_mat( double **mat);
				  
void Gamma(double * CX, double *CXXZ, double *Z, int * pin, int * qin, 
		   double * lamin, double * lambda2, double * tol, int * maxit, double * Bout)
{

  int r,c,j,k, kit;
  double bdiff, bnew, H, J, AH, tmp;
  
  int p					= *pin;
  int q					= *qin;
  double **lam			= make_mat(p,q);
  double **CXinC		= make_mat(p,p);
  double **CXXThetainC	= make_mat(p,q);
  double **ThetainC		= make_mat(q,q); 
  double **B			= make_mat(p,q);

 for (r=0; r < p; r++)
  {
    for(c=0; c < q; c++)
    {
     lam[r][c]			= lamin[c*p+r];
	 ThetainC[r][c]		= Z[c*p+r];
	 CXinC[r][c]		= CX[c*p+r];
	 CXXThetainC[r][c]	= CXXZ[c*p+r];
     B[r][c]			= Bout[c*p+r];
    }
  }

  kit=0;
  bdiff=*tol+1;
  while( (bdiff > *tol) && (kit < *maxit) )
  {
    kit+=1;
    bdiff = 0;
    for(r=0; r < p; r++)
    {
      for(c=0; c <q; c++)
      {
		J=0;  
        if(lam[r][c]== *lambda2)
		{
		  for(k=0; k <q; k++)
          {  
		    if(ThetainC[k][c] != 0)
            {
			  for(j=0; j <p; j++)
			  {
				if(B[j][k] != 0)
				{
					J+=B[j][k]*CXinC[r][j]*ThetainC[k][c];  
				}
			  }
			}
		  }
		
		// Rprintf("(%d,%d):%d, %3f",r+1,c+1,0,J);
		// Rprintf("\n");
			
        H = B[r][c] + (CXXThetainC[r][c]-J)/(CXinC[r][r]*ThetainC[c][c]);
        AH = fabs(H);
        tmp =AH - lam[r][c]/(CXinC[r][r]*ThetainC[c][c]);
        bnew=0;
        if(tmp  > 0 )
        {
          if(H > 0)
          {
            bnew = tmp;
          }
          if( H < 0 )
          {
            bnew = -tmp;
          }
        }
        bdiff+=fabs(B[r][c]-bnew);
        B[r][c]=bnew;
		}
	  }
    }	
  }	
  for(c=0; c <q; c++)
  {
    for (r=0; r < p; r++)
    {
      Bout[c*p+r] = B[r][c];
    }
  }
  delete_mat(CXinC);
  delete_mat(CXXThetainC);
  delete_mat(ThetainC);
  delete_mat(lam);
  delete_mat(B);
}


double **make_mat(int nrow, int ncol)
{
  double ** mat;
  int k;
  mat = (double **) malloc(nrow*sizeof(double*));
  mat[0]=(double*) malloc(nrow*ncol*sizeof(double));
  for(k=1; k < nrow; k++)
    mat[k] = mat[k-1] + ncol;
  return mat;
}
void delete_mat( double **mat)
{
  free(mat[0]);
  free(mat);  
}

	  // for (int row=0; row<p; row++)
		  // {
		  // for(int columns=0; columns<q; columns++)
		 // if(B[row][columns]!=0)
			// {	  
          // Rprintf("(%d,%d):%d, %3f",row,columns,0,B[row][columns]);
		  // Rprintf("\n");
		  // }
		  // }

		  	// Rprintf("(%d,%d):%d, %3f",0,0,0,J);
			// Rprintf("\n");
